
package de.ivu.elect.presentation.wahlvorschlag.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.kandidatur.boundary.KandidaturConversationSelect;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlvorschlag.boundary.WahlvorschlagConversationSelect;
import de.ivu.elect.business.wahlvorschlag.entity.Liste;
import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonMeta;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.wahlvorschlagsperson.WahlvorschlagsPersonSearchView;

@Named(ListeWahlvorschlagsPersonSearchAction.COMPONENT_NAME)
public class ListeWahlvorschlagsPersonSearchAction extends AbstractListeAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "listeWahlvorschlagsPersonSearchAction";

  @Inject
  private transient WahlvorschlagConversationSelect wahlvorschlagConversationSelect;

  @Inject
  private transient KandidaturConversationSelect kandidaturConversationSelect;

  @Inject
  private transient WahlvorschlagsPersonMeta wahlvorschlagsPersonMeta;

  public ListeWahlvorschlagsPersonSearchAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLVORSCHLAGS_PERSON_SEARCH;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Liste liste) {
    return super.isDisabledInternal(liste) || isNurWas();
  }

  @Override
  protected String doIt(Liste entity) {
    wahlvorschlagConversationSelect.setEntity(entity);
    kandidaturConversationSelect.clearEntity();

    return WahlvorschlagsPersonSearchView.VIEW_ID;
  }

  @Override
  protected String getLocalizedLabel() {
    return getMessage(getLabelKey(), wahlvorschlagsPersonMeta.getMehrzahlMessage());
  }

  @Override
  public String getLabelKey() {
    return "entity.search.menu.item.label";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconSearch();
  }
}
